package jp.kiroru_inc.samples.sample5;

import java.text.SimpleDateFormat;

import android.app.ListActivity;
import android.content.Context;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.CallLog.Calls;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;
import android.widget.ImageView;
import android.widget.TextView;

/*
 * 発着信履歴を表示する
 */

public class MainActivity extends ListActivity {

    private String[] projection = {
            Calls._ID,          // 0
            Calls.TYPE,         // 1
            Calls.DATE,         // 2
            Calls.CACHED_NAME,  // 3
            Calls.NUMBER,       // 4
    };
    
    private static int INDEX_TYPE         = 1;
    private static int INDEX_DATE         = 2;
    private static int INDEX_CACHED_NAME  = 3;
    private static int INDEX_NUMBER       = 4;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Cursor c = managedQuery(
                Calls.CONTENT_URI, projection, null, null, Calls.DEFAULT_SORT_ORDER);
        MyAdapter adapter = new MyAdapter(this, c);
        setListAdapter(adapter);
    }
    
    private class MyAdapter extends CursorAdapter {

        public MyAdapter(Context context, Cursor c) {
            super(context, c);
        }

        @Override
        public View newView(Context context, Cursor cursor, ViewGroup parent) {
            return LayoutInflater.from(context).inflate(R.layout.row, parent, false);
        }
        
        @Override
        public void bindView(View view, Context context, Cursor cursor) {
            // タイプ
            int resId;
            int type = cursor.getInt(INDEX_TYPE);
            if (type == Calls.INCOMING_TYPE) {
                resId = android.R.drawable.sym_call_incoming;
            } else if (type == Calls.OUTGOING_TYPE) {
                resId = android.R.drawable.sym_call_outgoing;
            } else { // (type == Calls.MISSED_TYPE) 
                resId = android.R.drawable.sym_call_missed;
            }
            ImageView iv = (ImageView)view.findViewById(R.id.image);
            iv.setImageResource(resId);
            
            // 時刻
            long date = cursor.getLong(INDEX_DATE);
            SimpleDateFormat sdf1 = new SimpleDateFormat();
            sdf1.applyPattern("yyyy/MM/dd hh:mm");
            String text1 = sdf1.format(date);
            TextView tv1 = (TextView) view.findViewById(R.id.text1);
            tv1.setText(text1);
            
            // 名前
            String text2 = cursor.getString(INDEX_CACHED_NAME);
            TextView tv2 = (TextView) view.findViewById(R.id.text2);
            tv2.setText(text2);

            // 電話番号
            String text3 = cursor.getString(INDEX_NUMBER);
            TextView tv3 = (TextView) view.findViewById(R.id.text3);
            tv3.setText(text3);
        }
    }
}